controllers/SiteController.php
<?php

namespace app\controllers;

use app\models\Caracteristicas;
use app\models\Fotos;
use app\models\Prendas;
use Yii;
use yii\data\ActiveDataProvider;
use yii\data\ArrayDataProvider;
use yii\data\SqlDataProvider;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use yii\web\Controller;
use const YII_ENV_TEST;

class SiteController extends Controller {

    /**
     * {@inheritdoc}
     */
    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex() {
        return $this->render('index');
    }

    /** mostrando  un array enumerado
     *  utilizando Html::ul y un foreach
     */
    public function actionEjercicio1() {

        // creo el array  
        $datos = [];
        
        // introduzcon en el array numeros
        // desde el 0 al 100
        for ($c = 0; $c < 100; $c++) {
            $datos[$c] = $c;
            //array_push($datos,$c);
        }

        // mostrar el array
        // enumerado de numeros
        // para mostrra contenido se lo mando a la vista
        return $this->render("ejercicio1", [
                    "datos" => $datos
        ]);
    }

    /**
     * Mostrar un array enumerado de arrays asociativos
     * Para realizarlo utilizo un Html::ul
     * y tambien lo realizo con foreach
     * Creo una subvista para mostrar cada registro
     */
    public function actionEjercicio2() {
        // creo el array enumerado de arrays 
        // asociativos (bidimensional)
        
        $visitas = [
            [
                "mes" => "Mayo",
                "visitas" => 10000
            ],
            [
                "mes" => "Junio",
                "visitas" => 100000
            ],
            [
                "mes" => "Julio",
                "visitas" => 200000
            ],
            [
                "mes" => "Agosto",
                "visitas" => 300000
            ],
        ];
        
        //para mostrar el array enumerado de arrays asociativos
        // utilizo en la vista Html::ul o foreach
        
        return $this->render("ejercicio2",[
            "visitas" => $visitas
        ]);
    }
    
    /**
     * Mostrar un array bidimensional es decir un array enumerado de 
     * arrays asociativos utilizando un widget denominado GRIDVIEW
     * para mostrarlo
     */
    
    public function actionEjercicio3(){
         
        // creo el array bidimensional
        $visitas = [
            [
                "mes" => "Mayo",
                "visitas" => 10000
            ],
            [
                "mes" => "Junio",
                "visitas" => 100000
            ],
            [
                "mes" => "Julio",
                "visitas" => 200000
            ],
            [
                "mes" => "Agosto",
                "visitas" => 300000
            ],
        ];
        
        // mostrar el contenido del array en una vista utilizando GRIDVIEW
        
        //primero creo el proveedor de datos
        $dataProvider=new ArrayDataProvider([
            "allModels" => $visitas
        ]);
        
        
        // mando el proveedor de datos a la vista
        return $this->render("ejercicio3",[
            "dataProvider" => $dataProvider,
        ]);
                
    }
    
    /**
     * Mostrar un array bidimensional es decir un array enumerado de 
     * arrays asociativos utilizando un widget denominado GRIDVIEW
     * para mostrarlo
     */
    public function actionEjercicio4(){
        // array enumerado de arrays asociativos
        
        $ventas=[
            [
                "idVenta" => 1,
                "cantidad" =>100,
                "producto" => 56,
                "precioTotal" => 560,
                "poblacion" => "Santander",
            ],
            [
                "idVenta" => 2,
                "cantidad" =>200,
                "producto" => 53,
                "precioTotal" => 5600,
                "poblacion" => "Santander",
            ],
            [
                "idVenta" => 3,
                "cantidad" =>200,
                "producto" => 50,
                "precioTotal" => 1600,
                "poblacion" => "Santander",
            ]
        ];
        
        //convierto el array en un proveedor de datos
        $dataProvider= new ArrayDataProvider([
            "allModels" => $ventas
        ]);
        
        // mando el proveedor de datos a la vista
        // que utilizando un widget (GRIDVIEW) muestra los datos
        return $this->render("ejercicio4",[
            "dataProvider" => $dataProvider
        ]);
                
    }
    
    /**
     * Mostrar un array bidimensional es decir un array enumerado de 
     * arrays asociativos utilizando un widget denominado LISTVIEW
     * para mostrarlo
    */
        
    public function actionEjercicio5(){
       // creo el array 
        $visitas = [
            [
                "mes" => "Mayo",
                "visitas" => 10000
            ],
            [
                "mes" => "Junio",
                "visitas" => 100000
            ],
            [
                "mes" => "Julio",
                "visitas" => 200000
            ],
            [
                "mes" => "Agosto",
                "visitas" => 300000
            ],
        ];
        
        
        // mostrar el array con el widget ListView
        
        // crear un dataProvider
        $dataProvider = new ArrayDataProvider([
            "allModels" => $visitas
        ]);
        
        // llamo a la vista y le paso el dataprovider
        // para que lo utilice en el widget ListView
        return $this->render("ejercicio5",[
            "dataProvider" => $dataProvider
        ]);
        
    }
    
    /**
     * Mostrar un array bidimensional es decir un array enumerado de 
     * arrays asociativos utilizando un widget denominado LISTVIEW
     * para mostrarlo
    */
    
    public function actionEjercicio6(){
          // array enumerado de arrays asociativos
        
        $ventas=[
            [
                "idVenta" => 1,
                "cantidad" =>100,
                "producto" => 56,
                "precioTotal" => 560,
                "poblacion" => "Santander",
            ],
            [
                "idVenta" => 2,
                "cantidad" =>200,
                "producto" => 53,
                "precioTotal" => 5600,
                "poblacion" => "Santander",
            ],
            [
                "idVenta" => 3,
                "cantidad" =>200,
                "producto" => 50,
                "precioTotal" => 1600,
                "poblacion" => "Santander",
            ]
        ];
        
        $dataProvider=new ArrayDataProvider([
            "allModels" => $ventas
        ]);
        
        return $this->render("ejercicio6",[
            "dataProvider" => $dataProvider
        ]);
    }
    
    
    /**
     * Mostrar un array bidimensional es decir un array enumerado de 
     * arrays asociativos utilizando un widget denominado GRIDVIEW
     * para mostrarlo.
     * 
     * El Array Bidimensional lo saco de una Peticion a un 
     * servidor API REST
     */
    
    public function actionEjercicio7(){
        // api key 
        // 73213b0e77d5466796b0cdb49808e28c
        
        // direccion del servidor api rest donde voy a solicitar datos
        // GET
        $url="https://newsapi.org/v2/everything?q=php&language=es&apiKey=73213b0e77d5466796b0cdb49808e28c";
        
        // lee el contenido de un fichero
        // leer como string los datos solicitados
        $contenido=file_get_contents($url);
        
        // convierte el texto en formato JSON
        // en un objeto de php
        $resultado=json_decode($contenido);
        
        // del objeto leo la propiedad articles
        // que es un array enumerado de arrays asociativos
        $noticias=$resultado->articles;
        
        // crear un dataprovider desde un array
        $dataProvider=new ArrayDataProvider([
            "allModels" => $noticias
        ]);
        
        // mando el dataProvider a la vista
        // para que el widget GRIDVIEW lo muestre
        return $this->render("ejercicio7",[
            "dataProvider" => $dataProvider
        ]);
    
    }

    /**
     * Mostrar un array bidimensional es decir un array enumerado de 
     * arrays asociativos utilizando un widget denominado GRIDVIEW
     * para mostrarlo.
     * 
     * El Array Bidimensional lo saco de una Peticion a un 
     * servidor API REST
     */
    
    public function actionEjercicio8(){
        // api key 
        // 73213b0e77d5466796b0cdb49808e28c
        
        // colocar todas las noticias en un gridview con este formato
        // numero orden, fecha de publicacion, foto, title, autor de la noticia, enlace 
        $url="https://newsapi.org/v2/top-headlines?language=es&apiKey=73213b0e77d5466796b0cdb49808e28c";
        
        $contenido= file_get_contents($url);

views/site/_ejercicio2.php
<?php

echo "<div>";
echo "Mes: " . $registro["mes"];
echo "</div>";
echo "<div>";
echo "Numero de visitas: " . $registro["visitas"];
echo "</div>";

views/site/_ejercicio5.php
<?php

// aqui tengo que mostrar los campos de mi
// array asociativo
?>

<div class="card" style="width: 18rem;">
  <div class="card-header">
    <?= $model["mes"] ?>
  </div>
  <ul class="list-group list-group-flush">
    <li class="list-group-item">Visitas: <?= $model["visitas"] ?></li>
  </ul>
</div>

views/site/ejercicio1.php
<?php

use yii\helpers\Html;

// mostrarlo con el helper
echo Html::ul($datos);

// mostrarlo con foreach
foreach($datos as $dato){
    echo "<div>{$dato}</div>";
}

views/site/ejercicio12.php
<?php

use yii\grid\GridView;

echo GridView::widget([
    "dataProvider" => $dataProvider
]);

views/site/ejercicio14.php
<?php

use yii\grid\GridView;

echo GridView::widget([
    "dataProvider" => $dataProvider
]);

views/site/ejercicio3.php
<?php

use yii\grid\GridView;
use yii\helpers\Html;

// coloco un boton en la vista para mostrar los datos 
// desde un LISTVIEW que realizo en la accion ejercicio5
echo Html::a("Lista",["site/ejercicio5"],['class'=>'btn btn-primary m-3']);

// coloco el mismo boton pero sin utilizar Html::a y utilizando Url::to
?>

<a class="btn btn-primary m-3" href="<?= \yii\helpers\Url::to(["site/ejercicio5"])?>">Lista</a>   

<?php
// colocamos el gridview
echo GridView::widget([
   "dataProvider" => $dataProvider
]);

?> 

views/site/ejercicio4.php
<?php

use yii\grid\GridView;

echo GridView::widget([
    "dataProvider" => $dataProvider
]);

views/site/ejercicio5.php
<?php

use yii\helpers\Html;
use yii\widgets\ListView;

// boton para llevarnos a la accion ejercicio3
// que me muestra los datos en un GRIDVIEW
echo Html::a(
        "Tabla", //label
        ["site/ejercicio3"], // controlador/accion
        ["class"=>"btn btn-primary m-3"] // clases de bootstrap
        );


// mostrar el LISTVIEW
echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => "_ejercicio5", // el LISTVIEW necesita un subvista
]);

views/site/ejercicio6.php
<?php

use yii\widgets\ListView;


echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => "_ejercicio6",
]);

views/site/ejercicio7.php
<?php

use yii\grid\GridView;
use yii\helpers\Html;

// modificar el GRIDVIEW para mostrar imagenes y enlaces


echo GridView::widget([
    "dataProvider" => $dataProvider,
    "columns" =>[
        ['class' => 'yii\grid\SerialColumn'], // numero orden
        // campos a mostrar
        "author",
        "title",
        // campo al que cambio el label
        [
            'attribute' => 'description',
            'label' => 'Descripcion'
        ],
        
        // campo de imagen
        // un campo que tiene la url de una imagen
        // me coloca la imagen
        [
            'label' => 'Imagen',
            'content' => function($dato){
                return Html::img($dato->urlToImage,["width"=>200]);
            }
        ],
                
        // campo de imagen
        // un campo que tiene la url de una imagen
        // me coloca la imagen
        [
            'label' => 'Imagen 1',
            'format' => 'raw',
            'value' => function($dato){
                return Html::img($dato->urlToImage,["width"=>200]);
            }
        ],   
                
        // campo de url
        // un campo que contiene una URL 
        // y quiero colocar un boton que me permita
        // ir a la URL
        [ 
            'label' => ' Ir a la noticia',
            'content' => function($dato){
                return Html::a(
                        "Ver Noticia completa",
                        $dato->url,
                        ["class"=>"btn btn-primary"]
                    );
            }
        ],
                
    ],
    // estilos visuales utilizando bootstrap
    'tableOptions' =>['class' => 'table table-dark table-striped table-bordered'],
    // cambiando la estructura del gridview
    'layout'=>"{pager}\n{summary}\n{items}\n{summary}\n{pager}",
    
]);

views/site/ejercicio8.php
<?php

use yii\grid\GridView;
use yii\helpers\Html;
echo GridView::widget([
    "dataProvider" => $dataProvider,
    "columns" =>[
        ['class' => 'yii\grid\SerialColumn'], // numero orden
        [
            'label' => 'fecha Publicación',
            'attribute' => 'publishedAt'
        ],
        [
            'label' => 'Foto',
            'content' => function ($dato){
                return Html::img($dato->urlToImage,["width"=>200]);
            }
        ],
        'title',
        [
            'label' => 'Autor de la noticia',
            'attribute' => 'author'
        ],
        [
            'label' => 'enlace',
            'content' => function($dato){
                return Html::a(
                        "Ver Noticia",
                        $dato->url,
                        ["class"=>"btn btn-primary"]
                        );
            }
        ]
    ],
]);

views/site/ejercicio9.php
<?php

echo yii\grid\GridView::widget([
    "dataProvider" => $dataProvider
]);

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>